## Script (Python) "render_field"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=node, info
##title=
##
td_css = node.getAttribute('css')
td_class  = (td_css.find(':')==-1 and td_css) or ''
td_style = td_css and (not td_class and ' style="%s"'%td_css) or ''

content = ''
if context.is_field_simple(node):
    # find p first (FIXME: inefficient)
    for child in node.childNodes:
        if child.nodeType == node.ELEMENT_NODE:
            break
    node = child
    if len(node.childNodes) == 0:
        content = '&nbsp;'
    if (len(node.childNodes) == 1 and hasattr(node.childNodes[0], 'data') and 
            len(node.childNodes[0].data.strip()) == 0):
        content = '&nbsp;'
    else:
        content = context.service_editorsupport.render_text_as_html(node)
else:
    context.service_editor.setViewer('service_sub_previewer')
    content = context.service_editor.renderView(node)

return '<td class="align-%s;%s" width="%s"%s>%s</td>' % (info['align'],
                                                         td_class, 
                                                         info['html_width'],
                                                         td_style,
                                                         content)
