## Script (Python) "render"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
request = context.REQUEST
node = request.node
columns_info = context.get_columns_info()
request.set('columns_info',columns_info)

# FIXME: Using CSS this hairball is slightly less hairy
# than is used to be
caption = ""
nr_of_columns = len(columns_info)
type = node.getAttribute('type')
service_editor = context.service_editor

table_data = []
for child in node.childNodes:
    if child.nodeType != node.ELEMENT_NODE:
        continue

    r_css = child.getAttribute('css')
    if r_css:
        row_class  = (r_css.find(':')==-1 and ' class="%s"'%r_css) or ''
        row_style = (not row_class and ' style="%s"'%r_css) or ''
        css_styles = (row_class!='' and row_class) or (row_style!='' and row_style) or ''
    else:
        css_styles = ''
        
    if child.nodeName == 'custom_row_heading':
        content = service_editor.renderView(child)
        table_data.append('<tr%s>\n%s\n</tr>'%(css_styles,content))
    if child.nodeName == 'row':
        request.set('node',child)
        table_data.append('<tr%s>\n%s\n</tr>'%(css_styles,service_editor.renderView(child)))
    if child.nodeName == 'row_heading':
        table_data.append(
            '<tr class="rowheading">\n<td colspan="%s">\n  %s\n</td>\n</tr>' % (
            nr_of_columns, 
            context.service_editorsupport.render_heading_as_html(child)))

table = []
table.append("""<table class="silvatable %s" width="100%%" cellspacing="0" cellpadding="3px">""" % (type))
# this is always empty in rendered html
# table.append("""<caption>%s</caption>""" % (caption))
for col in columns_info:
    table.append("""<col width="%s" class="align-%s" valign="top"/>""" % (
        col['html_width'], col['align']))
table.append("""<tbody>""")
table.append('\n'.join(table_data))
table.append("""</tbody>""")
table.append("""</table>""")

return '\n'.join(table) + '\n'
