## Script (Python) "render_field"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=node, info, colspan
##title=
##
if context.is_field_simple(node):
    # find p first (FIXME: inefficient)
    for child in node.childNodes:
        if child.nodeType == node.ELEMENT_NODE:
            break
    node = child
    if len(node.childNodes) == 0:
        return '<td class="custom-row-heading align-%s" colspan="%s">&nbsp;</td>' % (info['align'],colspan)
    if (len(node.childNodes) == 1 and hasattr(node.childNodes[0], 'data') and 
        len(node.childNodes[0].data.strip()) == 0):
        return '<td class="custom-row-heading align-%s" colspan="%s">&nbsp;</td>' % (info['align'], colspan)
    else:
        return '<td class="custom-row-heading align-%s" colspan="%s">%s</td>' % (info['align'], colspan, 
            context.service_editorsupport.render_text_as_html(node))
else:
    context.service_editor.setViewer('service_sub_viewer')
    content = context.service_editor.renderView(node)
    context.REQUEST.set('content',content)
    return '<td class="custom-row-heading align-%s" colspan="%s">%s</td>'%(info['align'], colspan, content)
